
#include <vdr/thread.h>
#include <vdr/player.h>
#include <sys/time.h>

/* DEFINITIONS */

#define LCD_PORT "/dev/ttyS0"

#define POWERLED_GREEN_BLINK     "\x90\x80"
#define POWERLED_GREEN_ON        "\x90\x08" // or "0x90 0x01"
#define POWERLED_RED_ON	         "\x90\x10"
#define BASICLED_ON		 "\x90\x40"
#define BASICLED_OFF		 "\x90\x04"
#define MESSAGELED_BLINK_ON	 "\x90\x20"
#define MESSAGELED_OFF		 "\x90\x02"

#define POWERBUTTON_ON		 "\x94\x12" // setkeycodes e010 xx
#define POWERBUTTON_OFF		 "\x94\x21"
#define POWERBUTTON_SCANCODE_ON  "\x94\x03"
#define POWERBUTTON_SCANCODE_OFF "\x94\x30"

#define LCD_WRITE_TEXT_LINE0	 "\x9A\x02" // + \x00
#define LCD_WRITE_TEXT_LINE1	 "\x9A\x03" // + \x00
#define LCD_CLEAR		 "\x9B"     // + \x00
#define LCD_LEDBRIGHTNESS	 "\xF0"


class aLCD : public cThread {
 private:
  char line0[21], oldline0[21], chline0[21], recline0[21];
  char line1[21], oldline1[21], chline1[21], recline1[21];
  char output[30], volline1[21];
  char RecordName[41];
  int percent, volume;
  int wait;
  int lcdmodus, oldmodus;
#ifdef ADEBUG
  FILE *fd;
  FILE *open_port(void);
#else
  int fd;
  int open_port(void);
#endif
  bool stop, running, title;
  struct timeval now;
  void close_port();
  void powerbutton(bool status);
  void init_display();
  void setup_port();
  void clear_text();
  void print_line(int line, char text[21]);
  virtual void Action(void);
  cControl *PlayControl;

 public:
  aLCD();
  ~aLCD();
  void SetVolumeBar(int percent);
  void SetProgressBar(int percent);
  void SetChannelName(const char *Name);
  void SetChannel(int ChannelNumber);
  void SetChannelInfo(const char *Info);
  void ReplayControl(cControl *Control, const char *Name);
  void SetRecording(int card, const char *Name);
  void SetProgramme(const char *PresentTitle);
  void SetLEDBrightness(const int brightness);
  void SetVolume(int volume, bool muted);
  bool refresh;
  };

